package FileService;
import ReplicProt.IService;

public class Service implements IService {

  public static class Operation implements IOperation {
    // insert fields and methods needed by all operations of this service
  }

  public static class Response implements IResponse {
    // insert fields and methods needed by all responses of this service
  }

  // returns a non-negative int that identifies the newly created file.
  // the response indicates whether the operation succeeded (or an error
  // occurred).
  public static class Create extends Operation {
  }

  // removes the indicated file.
  // the response indicates whether the operation succeeded,
  // the file does not exist, or an error occurred
  public static class Remove extends Operation {
    int file;
  }

  // reads data from file and produces a response containing a byte array 
  // containing the data.
  // the length of the array indicates how many bytes were read;
  // this may be less than <size>, if fewer than <size> bytes are available.
  // the response also indicates whether an error occurred
  //  (e.g., file does not exist).
  public static class Read extends Operation {
    int file;
    int offset;
    int size;
  }

  // writes the data to the file.  
  // the response indicates whether an error occurred
  public static class Write extends Operation {
    int file;
    int offset;
    byte[] data;
  }

  // response contains the size of the file, in bytes.
  // the response also indicates whether an error occurred
  public static class GetSize extends Operation {
    int file;
  }

  // insert other classes, fields and methods
  // other classes can be defined anywhere in this package; 
  // they don't need to be inner classes.

  private int version = 0;

  public int getVersion() {
    return version;
  }

  public void doOp(IOperation op) {
    if (!(op instanceof Operation)) {
      // ...
    }
    else {
    // ...
    }
  }

  public IResponse response(IOperation op) {
    return null;
  }

  public boolean reflects(IOperation op) {
    return true;
  }

  public Service() {
  }

}
